/*
 * Copyright (C) 1997 Brad Rossiter
 * Author: Brad Rossiter rossib@cloudnet.com
 *                       rossiter@eeyore.stcloudstate.edu
 *                       Webpage www.cloudnet.com/~rossib
 *
 * guestbook.c Version 1.1 8/21/97
 * This is a sample cgi client using libcgi library v1.1
 *                                                     
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                
 *
 */

#include <stdio.h>

#ifdef ORION
#include "/home/www/kendeco/src/libcgi/libcgi.h"
#else
#include <libcgi.h>
#endif           

int main()
{
     int smtp_socket;

     HTML_FORM form;

    /*
     * These variables are not necessarily needed for small forms such
     * as this (You can use get_formvar() directly if you wanted too).
     * However, it allows the client program here to work with the
     * data more easily.  These variables all corrispond to an INPUT
     * variable on the html form.
     *
     */

     FORM_DATA first_name,
               last_name,
               telephone,
               email,
               customer,
               company,
               business,
               co_url,
               title,
               co_telephone,
               fax,
               address,
               city,
               state,
               zip,
               comments;


    /* Program Code */

    /*
     * cgi_initialize_form is getting all the data from the html form.
     * get_formvar is returning pointers to different variables in the form.
     * The TRUE here tells the web server (httpd) that it should expect to
     * have html returned from the cgi program.  If FALSE is used, then
     * no html should be expected back.
     *
     */

     cgi_initialize_form(&form,TRUE);

     first_name    = get_formvar("first_name",form);
     last_name     = get_formvar("last_name",form);
     telephone     = get_formvar("telephone",form);
     email         = get_formvar("email",form);
     customer      = get_formvar("customer",form);
     company       = get_formvar("company",form);
     business      = get_formvar("business",form);
     co_url        = get_formvar("co_url",form);
     title         = get_formvar("title",form);
     co_telephone  = get_formvar("co_telephone",form);
     fax           = get_formvar("fax",form);
     address       = get_formvar("address",form);
     city          = get_formvar("city",form);
     state         = get_formvar("state",form);
     zip           = get_formvar("zip",form);
     comments      = get_formvar("comments",form);

/*
 * These ifdefs below are used to I can compile on different
 * systems without too much messing around with the code.
 *
 */

#ifdef ORION
     if((smtp_socket = cgi_SMTP_open("orion.cloudnet.com",
          "GuestBook","bradr@kendeco.com","Guest Book Reply")) < 0)
#else
     if((smtp_socket = cgi_SMTP_open("www.rovnet.com",
          "GuestBook","sentari@www.rovnet.com","Guest Book Reply")) < 0)
#endif
     {
       printf("<CENTER><H1>cgi_SMTP_mail ERROR [%d] Unable to send this mail message.</H1><CENTER>",smtp_socket);
     }
     else
     {
          socket_printf(smtp_socket,"This E-Mail has been sent via the WWW from the Generic LIBCGI Guest Book.\n");
          socket_printf(smtp_socket,"Remote Hostname: %s\nRemote Address: %s\n"
                        ,form->globals->REMOTE_HOST,form->globals->REMOTE_ADDR);
	  socket_printf(smtp_socket,"\nName           : %s %s\n",first_name,last_name);
          socket_printf(smtp_socket,"Telephone      : %s\nE-Mail Address : %s\n",telephone,email);
          socket_printf(smtp_socket,"\nCurrent Customer    : %s",customer);
          socket_printf(smtp_socket,"\nCompany             : %s\nCompany WWW Address : %s\n",company,co_url);
          socket_printf(smtp_socket,"Line of Business    : %s\n",business);
          socket_printf(smtp_socket,"Position in Company : %s\nCompany Telephone   : %s\n",title,co_telephone);
          socket_printf(smtp_socket,"Company Fax Number  : %s\n\nCompany Address : %s\n",fax,address);      
          socket_printf(smtp_socket,"City: %s     State: %s     Zip Code: %s\n",city,state,zip);
          socket_printf(smtp_socket,"\n[Guest Comments]\n%s\n[End Guest Comments]\n",comments);    
	  cgi_SMTP_close(smtp_socket);

          printf("<CENTER><H1>Thank you for filling out our Guest Book.<H1></CENTER>");
	  printf("<CENTER><H1>Your form has been sent to a Generic Representitive.</H1></CENTER>");
     }

     page_bottom(10); 

     cgi_free_form(&form);

     return 0;
}
