/*
 * Copyright (C) 1997 Brad Rossiter
 * Author: Brad Rossiter rossib@cloudnet.com
 *                       rossiter@eeyore.stcloudstate.edu
 *                       Webpage www.cloudnet.com/~rossib  
 *
 * libcgi Version 1.1 8/21/97
 * This is libcgi (header file), C library for writing CGI applications.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */                                                               

#define      SMTP_OK              "250 "
#define      MAX_MESSAGE_BUFFER     8196
#define      MAX_PARSE_VARIABLES     100
#define      BOTTEM               "./html/bottom.html"
#define      TRUE                      1
#define      FALSE                     0

/*************************************************************************/
/* This Structure consists of the CGI Environment Variables as           */
/* specified by NCSA                                                     */
/*************************************************************************/
struct cgigs
{
	char *SERVER_SOFTWARE;
	char *SERVER_NAME;
	char *GATEWAY_INTERFACE;
	char *SERVER_PROTOCOL;
	char *SERVER_PORT;
	char *REQUEST_METHOD;
	char *PATH_INFO;
	char *PATH_TRANSLATED;
	char *SCRIPT_NAME;
	char *QUERY_STRING;
	char *REMOTE_HOST;
	char *REMOTE_ADDR;
	char *AUTH_TYPE;
	char *REMOTE_USER;
	char *REMOTE_IDENT;
	char *CONTENT_TYPE;
	long  CONTENT_LENGTH;
	char *HTTP_ACCEPT;
	char *HTTP_USER_AGENT;
};

typedef struct cgigs cgi_gs;
typedef char *FORM_DATA;

struct cgi_form_data 
{
	char *var_name;
	FORM_DATA data;
	struct cgi_form_data *next;
	struct cgi_form_data *prior;
};

typedef struct cgi_form_data FORM_ELEMENT;
typedef FORM_ELEMENT *LINK;

struct html_form
{
	cgi_gs *globals;
        LINK f_head;
	LINK f_tail;
}; 

typedef struct html_form *HTML_FORM;

/*************************************************************************/
/* Function prototypes -- See readme.txt/libcgi.c for descriptions       */
/*************************************************************************/

void create_list(LINK *, LINK *);
void cgi_free_form(HTML_FORM *form);
void insert_element(LINK,LINK);
void display_list(HTML_FORM form);
FORM_DATA get_formvar(char *var_name, HTML_FORM form);
void cgi_initialize_form(HTML_FORM *form, int choice);
void cgi_get_globals(cgi_gs *global);
void cgi_get_form(cgi_gs,LINK *f_head,LINK *f_tail);
FORM_DATA cgi_build_string(char *raw_string);
void cgi_print_header(int choice);
char hex_to_char (char *string);
int cgi_SMTP_open(char *smtp_host, char *mail_from,
		  char *mail_to, char *subject);
int cgi_SMTP_close(int sock);
int socket_printf(int sock, char *message,...);
int page_bottom(int lines);
void filter_string(char *string);

/*************************************************************************/
